
import java.awt.*;
import java.applet.*;
import java.awt.event.MouseListener;
import java.awt.event.MouseMotionListener;
import java.awt.event.MouseEvent;

public class Main extends Applet implements Runnable, MouseListener, MouseMotionListener{
	//======================================================================================================
	//applet--------------------------
	//======================================================================================================
    	int width, height;
	Image imagebuffer;
	Graphics b;
	Thread t = null;

    public void init() {
        width = getSize().width; height = getSize().height;
		setBackground(Color.white);
		imagebuffer = createImage(width, height);
		b = imagebuffer.getGraphics();
		b.setColor(Color.white);
		addMouseListener( this );
		addMouseMotionListener( this );
		setFocusable(true);
		//-----
		begin();
		//-----
    }
	
	public void start(){
		if (t == null) { t = new Thread(this); t.start(); }
	}
	public void run(){
		try{
			while (true) {
				//-----
				loop();
				//-----
				repaint();
				t.sleep(40);
			}
		}
		catch (InterruptedException e) { }
	}
		
    public void paint (Graphics g) {
		b.clearRect(0,0,width,height);
		//---------
		draw(b);
		//---------
		g.drawImage(imagebuffer,0,0,this);
	}
	public void update (Graphics g) {
		paint(g);
	}
	
	public void mouseEntered( MouseEvent e ) {}
	public void mouseExited( MouseEvent e ) {}
	public void mouseClicked( MouseEvent e ) {}
	public void mousePressed( MouseEvent e ) {
		mouse_down();
	}
	public void mouseReleased( MouseEvent e ) {
		mouse_up();
	}
	public void mouseMoved( MouseEvent e ) 	{  
		mouse( e.getX(), e.getY()); 
		e.consume();
	}
	public void mouseDragged( MouseEvent e ) { }
	//============================================
	//freespace
	//============================================

	String Pyramid = "0.5:0.5:0.5 0.0:0.0:0.0 -0.5:-0.5:-0.5 0.5:-0.5:-0.5 0.5:-0.5:0.5 -0.5:-0.5:0.5\n0.5:0.5:0.5 0.0:0.0:0.0 -0.5:-0.5:-0.5 0.5:-0.5:-0.5 0.0:0.5:0.0\n0.5:0.5:0.5 0.0:0.0:0.0 0.5:-0.5:-0.5 0.5:-0.5:0.5 0.0:0.5:0.0\n0.5:0.5:0.5 0.0:0.0:0.0 0.5:-0.5:0.5 -0.5:-0.5:0.5 0.0:0.5:0.0\n0.5:0.5:0.5 0.0:0.0:0.0 -0.5:-0.5:-0.5 -0.5:-0.5:0.5 0.0:0.5:0.0\n";
	Model pyramid ;
	Zlist zlist;

	public void begin(){
		zlist = new Zlist();
		pyramid = new Model();
		pyramid.compose(Pyramid);
		pyramid.move(0,0,2.0);	//double
	}
		
	double turn,move;	//double
	public void loop(){
		pyramid.absolute();
		pyramid.rotate_y(-turn);
		pyramid.relative();
		pyramid.move(0,0,move);
	}
		
	public void mouse(int x, int y){
		turn = (double)(x - (width / 2))/(width*30); //double
		move = (double)(y - (height / 2))/(height*30); //double
	}
	public void mouse_down() {
	}
	public void mouse_up() {
	}
		
	public void draw(Graphics g){
		zlist.reset();
		pyramid.absolute();
		for (int i = 0 ; i < pyramid.polygons.num; i++) {
			Poly2d p = new Poly2d( pyramid.polygons.list[i] , pyramid.points, width, height);
			if (p.avoid == false) {
				zlist.append(p);
			}
		}
		pyramid.relative();
		zlist.sort();
		for (int i = 0; i < zlist.num; i++){
			g.setColor(zlist.list[i].fill);
			g.fillPolygon(zlist.list[i].x, zlist.list[i].y, zlist.list[i].num);
			g.setColor(zlist.list[i].draw);
			g.drawPolygon(zlist.list[i].x, zlist.list[i].y, zlist.list[i].num);
		}
	}
}
