//depend on Bittian.java
//depended by PointList

public class Point {
	double x;
	double y;
	double z;

	public Point() {
		this.x = 0;
		this.y = 0;
		this.z = 0;
	}
	public Point(double x, double y, double z) {
		this.x = x;
		this.y = y;
		this.z = z;
	}
	public Point(Point p) {
		this.x = p.x;
		this.y = p.y;
		this.z = p.z;
	}

	public void add(double x, double y, double z) {
		//ideal for move
		this.x += x;
		this.y += y;
		this.z += z;
	}
	public void add(Point p) {
		//ideal for translation of polypoint to center point
		this.x += p.x;
		this.y += p.y;
		this.z += p.z;
	}
	public void sub(Point p) {
		//ideal for reverse_translation of polypoint to center point
		this.x -= p.x;
		this.y -= p.y;
		this.z -= p.z;
	}
	public void mul(double m) {
		//ideal for zoom
		this.x *= m;
		this.y *= m;
		this.z *= m;
	}
	public void div(double d) {
		//avoid division per zero
		//ideal for reverse zoom
		if (d == 0) {
			this.x = 0;
			this.y = 0;
			this.z = 0;
		} 
		else {
			this.x /= d;
			this.y /= d;
			this.z /= d;	
		}
	}

	public double dot_product() { 
		//will make easy backface culling and zsort when point are first traducted
		return (this.x*this.x)+(this.y*this.y)+(this.z*this.z);
	}
	public double dot_product(double x, double y, double z) {
		x -= this.x; y -= this.y; z -= this.z;
		return (x*x)+(y*y)+(z*z);
	}
	public double dot_product(Point p) {
		//will make easy bounding sphere
		double x = p.x-this.x; y = p.y-this.y; z = p.z-this.z;
		return (x*x)+(y*y)+(z*z);
	}
	//a dot product for moving object direction can eleminate many collision detection

	public void rotate_x(double r) {
		double yy = this.y, zz = this.z, sin = Math.sin(r), cos = Math.cos(r);
		this.y = (yy*cos)-(zz*sin);
		this.z = (yy*sin)+(zz*cos);
	}
	public void rotate_y(double r) {
		double xx = this.x, zz = this.z, sin = Math.sin(r), cos = Math.cos(r);
		this.x = (zz*sin)+(xx*cos);
		this.z = (zz*cos)-(xx*sin);
	}
	public void rotate_z(double r) {
		double xx = this.x, yy = this.y, sin = Math.sin(r), cos = Math.cos(r);
		this.x = ((yy*sin)+(xx*cos))/0xffff;
		this.y = ((yy*cos)-(xx*sin))/0xffff;
	}
}
