import java.awt.Color;

public class Poly2d {
	int[] x;
	int[] y;
	double z;
	int num;
	Color fill;
	Color draw;
	boolean avoid;		//make sure this flag is false before adding it to draw list

	public Poly2d(Poly p, PointList points, int scale_w, int scale_h) {
			this.avoid = true;
			this.x = new int[p.num];
			this.y = new int[p.num];
			double tmpx = 0,tmpy = 0,tmpz = 0;
			int tmpc = 0 ;
			Point tmpP;
			for (this.num = 0; this.num < p.num; this.num++) {
				tmpP = points.list[ p.list[this.num] ];
				//avoid polygon behind		(bug fix)
				if (tmpP.z <= 0){
					return;
				}
				//transform 3d to 2d
				this.x[this.num] = (int)((scale_w * tmpP.x / tmpP.z) + scale_w)/2;		//double conversion
				this.y[this.num] = (int)(((scale_w * tmpP.y / tmpP.z) + scale_h)/2);		//double conversion
				//calculate the center of polygon by the way	(zsort)
				tmpx += tmpP.x;	
				tmpy += tmpP.y;	
				tmpz += tmpP.z;
				//avoid polygon completely offscreen  (acceleration)
				if (this.x[this.num] > scale_w || this.x[this.num] < 0 || this.y[this.num] > scale_h || this.y[this.num] < 0) {
					tmpc += 1;	//polygon clipping
				}
			}
			//avoid polygon completely offscreen
			if (tmpc == this.num) {
				return;
			}
			//calculate center of polygon
			tmpx /= p.num;
			tmpy /= p.num;
			tmpz /= p.num;
			//calculate distance for zsort
			this.z = (tmpx*tmpx + tmpy*tmpy + tmpz*tmpz);
			//color
			this.fill = p.color;
			this.draw = p.border;
			this.avoid = false;
	}
}
